<script lang="ts">
	import { createEventDispatcher, onMount } from 'svelte'

	interface Props {
		value?: string;
		items?: string[];
	}

	let { value = $bindable('Click to open'), items = ['one', 'two', 'three'] }: Props = $props();

	let activeElement: Element | null
	let details: HTMLDetailsElement = $state()
	let hasFocus: boolean = false

	const dispatch = createEventDispatcher()

	function onSelect(hex: string) {
		details.removeAttribute('open')
		value = hex
		dispatch('click', hex)
	}
</script>

<details id="details" bind:this={details}>
	<summary class:focus={hasFocus}
		><div style="background-color: {value}; width: 32px; height: 32px; display: inline-block;"></div>
		<span>{value}</span></summary
	>
	<ul>
		{#each items as item (item)}
			<li>
				<div
					class="item"
					role="button"
					tabindex="0"
					data-hex={item}
					style="--backgroundColour: {item}"
					onclick={(e) => onSelect(item)}
					onkeypress={(e) => onSelect(item)}
				>
					<span>{item}</span>
				</div>
			</li>
		{/each}
	</ul>
</details>

<style>
	details {
		position: relative;

		margin-right: 1rem;
	}

	details[open] {
		z-index: 1;
	}

	summary:focus {
		color: #ffffffdd;
	}

	summary div {
		border-radius: 5px;
		transform: translate(-10px, 10px);
	}

	.focus {
		color: #ffffffdd;
	}

	summary {
		padding: 1rem;
		cursor: pointer;
		border-radius: 5px;
		background-color: transparent;
		list-style: none;
		color: #ffffffaa;
		user-select: none;
		text-align: left;
	}

	summary::-webkit-details-marker {
		display: none;
	}

	details[open] summary:before {
		content: '';
		display: block;
		width: 100vw;
		height: 100vh;
		background: transparent;
		position: fixed;
		top: 0;
		left: 0;
	}

	summary:after {
		content: '';
		display: inline-block;
		float: right;
		color: #ffffffbb;
		width: 0.5rem;
		height: 0.5rem;
		border-bottom: 1px solid currentColor;
		border-left: 1px solid currentColor;
		border-bottom-left-radius: 2px;
		transform: rotate(45deg) translate(50%, 20px);
		transform-origin: center center;
		transition: transform ease-in-out 100ms;
	}

	summary:focus {
		outline: none;
	}

	details[open] summary:after {
		transform: rotate(-45deg) translate(-20px, 0px);
	}

	ul {
		width: 100%;
		background: #111;
		position: absolute;
		top: calc(100% + 0.5rem);
		left: 0;
		padding: 1rem;
		margin: 0;
		box-sizing: border-box;
		border-radius: 5px;
		max-height: 200px;
		overflow-y: auto;
		list-style: none;
		color: #ffffffaa;
		display: flex;
		column-gap: 1rem;
		flex-wrap: wrap;
		justify-content: center;
	}

	@media (min-width: 398px) {
		.item {
			width: 128px;
		}
	}

	@media (max-width: 398px) {
		.item {
			width: 60vw !important;
		}
	}

	li {
		margin: 0;
		padding: 1rem 0;
	}

	li:last-child {
		padding-bottom: 0;
		border-bottom: none;
	}

	label {
		width: 100%;
		cursor: pointer;
		justify-content: space-between;
	}

	label:hover {
		color: #ffffffdd;
	}

	span {
		margin-top: auto;
		margin-bottom: auto;
		text-transform: uppercase;
	}

	.item {
		height: 64px;
		color: #000;
		display: flex;
		justify-content: center;
		background-color: var(--backgroundColour);
		border-radius: 5px;
	}
</style>
